#include <stdio.h>
#include "list.h"

typedef struct foo {
	struct foo *next;
	int val;
} vlist;

int
show_vlist(ls_list *v) {
	printf("vlist %8d at %p\n", v ? ((vlist *)v)->val : 0, v);
	return 0;
}

void
set_vl(ls_list *v) {
	if (!v)
		return;
	((vlist *) v)->val = rand();
}

int
numcmp(const ls_list *v1, const ls_list *v2) {
	const vlist *vl1 = (vlist *) v1, *vl2 = (vlist *) v2;
	if (!v1) {
		if (v2)
			return -1;
		return 0;
	}
	if (!v2)
		return 1;

	return vl1->val - vl2->val;
}

int
main(void) {
	vlist *foo = (vlist *) ls_new(sizeof(vlist), set_vl);
	vlist *bar;
	int i;

	show_vlist((ls_list *) foo);

	for (i = 0; i < 7; ++i) {
		bar = (vlist *) ls_new(sizeof(vlist), set_vl);
		if (i % 2) {
			printf("appending ");
			foo = (vlist *) ls_append((ls_list *) foo, (ls_list *) bar);
		} else {
			printf("pushing   ");
			foo = (vlist *) ls_push((ls_list *) foo, (ls_list *) bar);
		}
		show_vlist((ls_list *) bar);
	}

	ls_iter((ls_list *) foo, show_vlist);

	printf("sorting:\n");

	foo = (vlist *) ls_sort((ls_list *) foo, -1, numcmp);

	ls_iter((ls_list *) foo, show_vlist);

	printf("reversing:\n");

	foo = (vlist *) ls_rev((ls_list *) foo);

	ls_iter((ls_list *) foo, show_vlist);

	ls_free((ls_list *) foo, NULL);

	return 0;
}
